/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.ext.authentication.manager;

import java.security.Principal;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import net.sf.jguard.ext.authentication.PersistedPrincipal;
import net.sf.jguard.core.organization.Organization;
import net.sf.jguard.core.principals.RolePrincipal;
import net.sf.jguard.ext.organization.PersistedOrganization;
import org.hibernate.Session;

/**
*
* @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
*/
public class HibernateConverterUtils {

     public static net.sf.jguard.ext.authentication.PersistedPrincipal getPersistedPrincipal(Principal ppal) {
        
        if (ppal instanceof RolePrincipal) {
            RolePrincipal rp = (RolePrincipal) ppal;
            Long id = rp.getId();
            net.sf.jguard.ext.authentication.PersistedPrincipal principal = null;
            if(id!=null){
                Session session = HibernateUtil.getSessionFactory().getCurrentSession();
                principal = (PersistedPrincipal) session.get(PersistedPrincipal.class,id);
                return principal;
            }else{
                principal = new net.sf.jguard.ext.authentication.PersistedPrincipal();
                principal.setClassName(ppal.getClass().getName());
                principal.setName(rp.getLocalName());
                principal.setApplicationName(rp.getApplicationName());
            }
            return principal;
        }else{
            return null;
        }
        
    }
     
      public static Set getjavaSecurityPrincipals(Set principals){
            Set ppals = new HashSet();
            Iterator it = principals.iterator();
            while(it.hasNext()){
                net.sf.jguard.ext.authentication.PersistedPrincipal principal = (net.sf.jguard.ext.authentication.PersistedPrincipal)it.next();
                String applicationName = principal.getApplicationName();
                String className = principal.getClassName();
                String name = principal.getName();
                
                if(RolePrincipal.class.getName().equals(className)){
                    RolePrincipal role = new RolePrincipal();
                    role.setApplicationName(applicationName);
                    role.setLocalName(name);
                    role.setId(principal.getId());
                    ppals.add(role);
                }
            }
            return ppals;
        }
        
        public static Set getPersistedPrincipals(Set ppals) {
        Set s = new HashSet();
        Iterator it = ppals.iterator();
        while (it.hasNext()) {
            java.security.Principal ppal = (java.security.Principal) it.next();
            net.sf.jguard.ext.authentication.PersistedPrincipal principal = getPersistedPrincipal(ppal);
            if(principal != null){
                s.add(principal);
            }
        }
        return s;
    }
     
     
   public static Set getOrganizations(Set persistedOrganizations){
    Set orgas = new HashSet();
    Iterator it = persistedOrganizations.iterator();
    while(it.hasNext()){
        PersistedOrganization org = (PersistedOrganization)it.next();
        Organization orga = org.toOrganization();
        orgas.add(orga);
    }
    return orgas;
   }
}
